//
// Computergraphik II
// Prof. Dr. Juergen Doellner
// Wintersemester 2001/2002
// 
// Rahmenprogramm fuer Aufgabenzettel 3
//
// Autoren: Florian Kirsch (kirsch@hpi.uni-potsdam.de)
//          Marc Nienhaus (nienhaus@hpi.uni-potsdam.de)
//          Juergen Doellner (doellner@hpi.uni-potsdam.de)
//

#ifndef CG_HSVCOLORS_H
#define CG_HSVCOLORS_H

#include "cgapplication.h"
#include "cgraster.h"

class CGHSVColors : public CGApplication {
public:
    CGHSVColors(int width, int height);

    virtual void onInit();
    virtual void onDraw();
    virtual void onSize(unsigned int newWidth,unsigned  int newHeight);
    virtual void onKey(unsigned char key);
    virtual void onIdle();

    virtual void onButton(MouseButton button, int x, int y);

	enum { SHOWNCOLORS = 128 };

private:

    enum MODE { DrawGrid, DrawCube };
    MODE mode_;

    // interne Raster-Klasse
    CGRaster raster_;

    // Fenstergroesse speichern
    int winWidth_;
    int winHeight_;
	int hSubWindow;

	Color clrFrom;
	Color clrTo;

    bool run_;  
    double angle_;

};

#endif // CG_HSVCOLORS_H
