//
// Computergraphik II
// Prof. Dr. Juergen Doellner
// Wintersemester 2001/02
// 
// Rahmenprogramm zu Aufgabenzettel 2
//

#ifndef CG_LINESTYLE_H
#define CG_LINESTYLE_H

#include "cgapplication.h"

class CGLinestyle : public CGApplication {
public:
    CGLinestyle();
    virtual ~CGLinestyle();

    // Ueberschreibe alle diese Ereignisse:
    virtual void onInit();
    virtual void onDraw();        
    virtual void onIdle();
    virtual void onKey(unsigned char key);    
    virtual void onSize(unsigned int newWidth, unsigned int newHeight);

    // value Methode
    unsigned char value(int x, int z) const;
    
private: 
	enum { HALOED, SEGMENTED };

    void drawScene();

    double haloewidth_;
	double segmentwidth_;
	int width_;
    int height_;
    double zoom_;
    bool run_;    
	bool culling_;
	bool lighting_;
	int mode_;
};

#endif

