//
// Computergraphik II
// Prof. Dr. Juergen Doellner
// Wintersemester 2001/02
// 
// Rahmenprogramm zu Aufgabenzettel 3
//

#ifndef CG_INTERPOLATION_H
#define CG_INTERPOLATION_H

#include "cgapplication.h"
#include "vector.h"

class CGInterpolation : public CGApplication {
public:
    CGInterpolation();
    virtual ~CGInterpolation();

    // Ueberschreibe alle diese Ereignisse:
    virtual void onInit();
    virtual void onDraw();        
    virtual void onIdle();
    virtual void onKey(unsigned char key);    
    virtual void onSize(unsigned int newWidth, unsigned int newHeight);

    // value Methode
    unsigned char value(int x, int z) const;
    
private: 

    void drawScene();
	void loadGeometry();
	void drawObject(const Vector& ref);

    int width_;
    int height_;
    double zoom_;
    bool run_;    
	bool culling_;

	unsigned int max_;
	unsigned int counter_;
	Vector ref_;
	Vector* list_;
};

#endif // CG_INTERPOLATION_H

