//
// Computergraphik II
// Prof. Dr. Juergen Doellner
// Wintersemester 2001/2002
// 
// Rahmenprogramm fuer Aufgabenzettel 3
//
// Autoren: Florian Kirsch (kirsch@hpi.uni-potsdam.de)
//          Marc Nienhaus (nienhaus@hpi.uni-potsdam.de)
//          Juergen Doellner (doellner@hpi.uni-potsdam.de)
//

#ifndef CG_RASTER_H
#define CG_RASTER_H

#include "color.h"
#include "cgapplication.h"

class CGRaster {
public:
    CGRaster(int width, int height);
    ~CGRaster();

    int width() const;
    int height() const;

    void clear(const Color& = Color());

    Color& getPixel(int x, int y) const;
    void setPixel(int x, int y, const Color&);

    void draw() const;

private:
    int width_;
    int height_;
    Color* raster_;
};

#endif // CG_RASTER_H
